#!/usr/bin/perl -w

use CLI;
use strict;

sub DoExit
{
	print $_[0]."\n";
	print "\n\nPress Enter to close this window";
	my $dummy = <>;
	exit();
}


print "Server Domain Name or IP ?\n>";
my $Server = <>;
chomp $Server;

print "login = postmaster\npassword ?\n>";
my $password = <>;
chomp $password;

my $cli = new CGP::CLI
	({
			PeerAddr => "$Server",
			PeerPort => 106,
			login    => 'postmaster',
			password => "$password"
	}) || DoExit "Can't login to CGPro: ".$CGP::ERR_STRING."\n";

my $domList = $cli->ListDomains() || DoExit "can't list domains";

my %domskinlist;
my %skinlist;
foreach my $domain (@$domList)
{
   my $AccountList = $cli->ListAccounts($domain) || DoExit "Error: ".$cli->getErrMessage.", quitting";

   foreach my $account (keys %$AccountList)
   {
      my $WebSkin = $cli->GetEffectiveWebUser("$account\@$domain")->{"SkinName"};
      $WebSkin = "[default or nameless skin]" if !defined $WebSkin;
      $WebSkin = "[default or nameless skin]" if !length $WebSkin;
      #print "$account\@$domain = $WebSkin\n";
      my @domusers = ();

      @domusers = @{$domskinlist{$domain}->{$WebSkin}} if defined $domskinlist{$domain}->{$WebSkin};
      $skinlist{$WebSkin} = 0 if (!defined $skinlist{$WebSkin});
      push @domusers, "$account\@$domain";

      $domskinlist{$domain}->{$WebSkin} = \@domusers;
      $skinlist{$WebSkin}++;
      print ".";
   }
}

foreach my $domain (@$domList)
{
	print "\nDomain: $domain\n";
	foreach my $skin (sort keys %{$domskinlist{$domain}})
	{
		print "\n\t$skin\n";
		print "\t\t$_\n" foreach (@{$domskinlist{$domain}{$skin}});
		print "\t\t---------------------\n\t\tTotal: " . (scalar @{$domskinlist{$domain}{$skin}}) . " users\n";
	}
	print "\n\n";
}

print "\nAll Domains summary:\n\n";
foreach my $skin (sort keys %skinlist)
{
	print "\t$skin: $skinlist{$skin} users\n";
}
print "\n\n";

$cli->Logout;

DoExit "";
